#<profile4xi profile = "10" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "sub_debug4xi.py">
#<abstract4xi abstract = "provides the function subdebugging4xi"/>
#<refer4xi reference = "util.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'sub_debug4xi' ] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import itertools
    import weakref
    import logging         
except:
    pass
try:                 # rare ones
    import atexit          
except:
    pass 
try:                 # imported-as ones 
    pass          
except:
    pass            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    pass
except:
    pass
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from print4xi import print4xi
from time4xi import time4xi
#" 
#/>



# -------------------------------------------------------------------------------------------------
#<function4xi function = "sub-debug4x" usage = " 
#     Class Finalizei: sub_debug('finalizer no longer registered')
#       sub_debug('finalizer calling %s with args %s and kwargs %s', self._callback, self._args, self._kwargs)
#                   _run_finalizers: sub_debug4xi('calling %s', finalizer)                
#
#     connection4xi.py:
#         sub_debug('listener created with address=%r', self._address)
#         sub_debug('closing listener with address=%r', address)
#
#     managers.py:
#         sub_debug('listener created with address=%r', self._address)
#         sub_debug('finalizer no longer registered')
#
#     reduction.py:
#         sub_debug('reducing handle %d', handle) <--- this is done after debug call
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def sub_debug4xi(msg, *args):
    '''
    sub_debug4xi function is used to provide more debug information
    '''
                  
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
    
        
    class2print = "sub_debug4xi"
    method2print = "sub_debug4xi"
    
    message2print = "{started" + "; sub-debug4xi-started: " + str(sub_debug4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    
                
    # ---------------------------------------------------------------------------------------------    
    #
    # --------------------------------------------------------------------------------------------- 
        
    message2print = "{passing" + "; msg-passing-to-print4xi-by-sub-debug4xi: " + str(msg) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
        
    message2print = "{informing" + "; replace-informing-by-sub-debug4xi: " + " * replace debug4xi calls with print4xi calls !"  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
    message2print = "{returning" + "; sub-debug4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
        
#</function4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of sub_debug4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
